<?php class containertype extends baseobject { 
	
	protected static $fields=array(
		'name'=>validator::REQUIRED,
		'containercategoryid'=>array(validator::REQUIRED, validator::INTEGER),
		'positions'=>array(validator::REQUIRED, validator::INTEGER),
	);
	
	protected static $helpTexts=array(
		'name'=>'A unique identifier for the container category',
		'containercategoryid'=>'The broad category of container, e.g., Puck',
		'positions'=>'How many items can be held in containers of this type',
	);
	
	protected static $adminSelect='SELECT SQL_CALC_FOUND_ROWS containertype.*, 
				containercategory.name AS containercategoryname, containercategory.userscancreate AS userscancreate
			FROM containertype, containercategory
			WHERE containercategory.id=containertype.containercategoryid ';
	protected static $normalSelect='SELECT SQL_CALC_FOUND_ROWS containertype.*, 
				containercategory.name AS containercategoryname, containercategory.userscancreate AS userscancreate
			FROM containertype, containercategory, project
			WHERE project.id= containertype.projectid AND containercategory.id=containertype.containercategoryid ';
	
	public static function create($request=array()){
		if(!static::canCreate()){
			throw new ForbiddenException('Only administrators and technicians can create container types');
		}
		$project=project::getByName(project::SHARED);
		$request['projectid']=$project['id'];
		$ret=parent::create($request,'containertype');
		return $ret;
	}

	public static function canCreate(){
		if(session::isAdmin()){ return true; }
		$grp=usergroup::getByName(usergroup::TECHNICIANS);
		return usergroup::userisingroup($grp['id']);
	}
	
}

?>