<?php
/**
 * Upgrades the database from version 1.1.0 to version 1.2.0.
 * DO NOT call this directly, it will fail.
 * To be included from classes/core/updater.class.php.
 * Assumes that logging has already been init()ed. Log class will throw ServerException if not.
 */

$tables=array();
$result=database::queryGetAll('SHOW TABLES');
foreach($result['rows'] as $row){
    foreach($row as $k=>$v){
        $tables[]=$v;
    }
}

//Plate table
Log::write(Log::LOGLEVEL_INFO, "Adding isdestroyed column to plate table...");
database::addColumnIfNotExists('plate','isdestroyed','BOOLEAN NOT NULL DEFAULT FALSE');

//Shipment destination
Log::write(Log::LOGLEVEL_INFO, "Changing shipmentdestination columns...");
Log::write(Log::LOGLEVEL_INFO, "Dropping unused columns...");
database::dropColumnIfExists('shipmentdestination','interfaceclass');
database::dropColumnIfExists('shipmentdestination','shipmentsubmiturl');
database::dropColumnIfExists('shipmentdestination','authenticateurl');
Log::write(Log::LOGLEVEL_INFO, "Adding new columns...");
database::addColumnIfNotExists('shipmentdestination','shipmenthandler',"VARCHAR(100) NOT NULL COMMENT 'The Javascript handler object - see js/shipping/handlers'");
database::addColumnIfNotExists('shipmentdestination','baseuri',"VARCHAR(100) NOT NULL COMMENT 'Base URI of the shipping API'");

Log::write(Log::LOGLEVEL_INFO, "Update script completed.");

//User config table
if(in_array('userconfig', $tables)){
    Log::write(Log::LOGLEVEL_INFO, "userconfig table already exists");
} else {
    Log::write(Log::LOGLEVEL_INFO, "Creating userconfig table...");
    database::query("
        CREATE TABLE IF NOT EXISTS userconfig (
                userid bigint(20) unsigned NOT NULL,
                `name` varchar(100) COLLATE utf8_bin NOT NULL,
                `value` varchar(250) COLLATE utf8_bin NOT NULL,
                UNIQUE KEY userid_propname (userid,`name`)
        ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin; 
    ");
    database::query(" 
        ALTER TABLE userconfig
        ADD CONSTRAINT userconfig_ibfk_1 FOREIGN KEY (userid) REFERENCES `user` (id) ON DELETE CASCADE ON UPDATE CASCADE; 
    ");
}