<?php class protein extends baseobject {
	
	protected static $fields=array(
			'name'=>validator::REQUIRED,
			'proteinacronym'=>validator::REQUIRED,
			'description'=>validator::REQUIRED,
	);
	
	protected static $helpTexts=array(
			'name'=>'A unique name for this protein',
			'proteinacronym'=>'Short code for synchrotron safety info',
			'description'=>'Short desription of this protein',
	);
	
	public static $defaultSortOrder='name ASC';
	
	public static function canCreate(){
		if(session::isAdmin()){ return true; }
		$grp=usergroup::getByName(usergroup::TECHNICIANS);
		if(usergroup::userisingroup($grp['id'])) return true;
		$userId=session::getUserId();
		$projects=session::getCreateProjects(true);
		foreach($projects['rows'] as $p){
			if($p['owner']==$userId){ return true; }
		}
		return false;
	}
	
	public static function create($request=array()){
		if(!session::isAdmin()){
			$proj=project::getById($request['projectid']); //NotFoundException if can't read it
			if($proj['owner']!=session::getUserId()){
				throw new ForbiddenException('You must own the project to create proteins and constructs in it');
			}
		}
		$result=parent::create($request);
		if(isset($result['created'])){
			//Create a "Full Length" construct with sequence(s) 
			$request['name']='Full length';
			$request['description']='The full sequence';
			$request['proteinid']=$result['created']['id'];
			construct::create($request); 
		}
		return $result;
	}
	
	public static function getconstructs($id,$request=array()){
		return construct::getByProperty('proteinid',$id,$request);
	}
	
}

?>